/* Program05_4
 *
 * A PB1 kimenetre kttt LED villogtatsa 
 * kb 0.5 Hz frekvencival. 
 *
 * A Timer2 idztt 1s ksleltetsre lltjuk, s az 
 * "update esemnyek" bekvetkeztekor tbillentjk a LED llapott.
 * Timer2 az alaprtelmezett 72 MHz-es rajelet szmllja.
 * A 16 bites elszmllt gy lltjuk be, hogy a f szmll
 * 10 kHz-es rajelet kapjon, gy a szmll szmlllsi hatrt
 * kzvetlenl tized ms egysgekben tudjuk megadni.
 * 
 * Felhasznlt forrsok: 
 * - Mazidi et al., STM32 Arm Programming for Embedded Systems
 *   http://www.microdigitaled.com/ARM/STM_ARM_books.html
 * - Alexander Tarasov: Storming STM32 course
 *   http://themagicsmoke.ru/courses/stm32/
 * 
 * Tested with Keil MDK-Lite v5.28 and STM32F1 DFP v2.3.0
 */
 
#include "stm32f10x.h"


int main(void) {
  /* PB1 konfigurlsa digitlis kimenetknt */
  RCC->APB2ENR |=  RCC_APB2ENR_IOPBEN;     // GPIOB rajel engedlyezs
  GPIOB->CRL &= ~(GPIO_CRL_MODE1|GPIO_CRL_CNF1); // CNF s Mode bitek trlse
  GPIOB->CRL |=  GPIO_CRL_MODE1_1;         // PB1 pushpull kimenet, max. 2 MHz
  /* Timer2 konfigurlsa */
  RCC->APB1ENR |= RCC_APB1ENR_TIM2EN;      // TIM2 rajel engedlyezs
  TIM2->PSC = SystemCoreClock/10000 - 1;   // 10 kHz-re osztjuk le az rajelet
  TIM2->ARR = 10000 - 1;                   // 10000-ig szmllunk (1000 ms)
  TIM2->CNT = 0;                           // Szmll nullzsa
  TIM2->CR1 |= TIM_CR1_CEN;                // Enable counter

  while (1) {
    while(!(TIM2->SR & TIM_SR_UIF));       // Update esemnyre vrunk
    TIM2->SR &= ~TIM_SR_UIF;               // UIF jelzbit trlse
    GPIOB->ODR ^= GPIO_ODR_ODR1;           // PB1 tbillentse
  }
}



