/* Program05_5
 *
 * A PB0 s PB1 kimenetekre kttt LED-ek villogtatsa 
 * ellentemben, 1 Hz frekvencival. 
 *
 * A Timer4 idztt 500 ms ksleltetsre lltjuk, s az 
 * "update esemnyek" bekvetkeztekor tbillentjk a LED-ek llapott.
 * A kiszolgls most megszaktsi szinten trtnik.
 * Timer4 az alaprtelmezett 72 MHz-es rajelet szmllja.
 * A 16 bites elszmllt gy lltjuk be, hogy a f szmll
 * 10 kHz-es rajelet kapjon, gy a szmll szmlllsi hatrt
 * kzvetlenl tized ms egysgekben tudjuk megadni.
 * 
 * Felhasznlt forrsok: 
 * - Mazidi et al., STM32 Arm Programming for Embedded Systems
 *   http://www.microdigitaled.com/ARM/STM_ARM_books.html
 * - Alexander Tarasov: Storming STM32 course
 *   http://themagicsmoke.ru/courses/stm32/
 * 
 * Tested with Keil MDK-Lite v5.28 and STM32F1 DFP v2.3.0
 */
 
#include "stm32f10x.h"

int main(void) {
  __disable_irq();                         // Megszaktsok globlis letiltsa
  /* PB0 s PB1 konfigurlsa digitlis kimenetknt */
  RCC->APB2ENR |=  RCC_APB2ENR_IOPBEN;     // GPIOB rajel engedlyezs
  GPIOB->CRL &= ~0x000000FF;               // CNF s Mode bitek trlse
  GPIOB->CRL |=  0x00000022;               // PB0 s PB1 pushpull kimenet, max. 2 MHz
  GPIOB->ODR |= GPIO_ODR_ODR0;             // PB0 1-be llts
  GPIOB->ODR &= ~GPIO_ODR_ODR1;            // PB1 trls
  /* Timer4 konfigurlsa */
  RCC->APB1ENR |= RCC_APB1ENR_TIM4EN;      // TIM4 idzt engedlyezse
  TIM4->PSC = SystemCoreClock/10000 - 1;   // 10 kHz-re osztjuk le az rajelet
  TIM4->ARR = 5000 - 1;                    // 5000-ig szmllunk (500 ms)
  TIM4->CNT = 0;                           // Szmll nullzsa
  TIM4->CR1 |= TIM_CR1_CEN;                // Szmlls engedlyezse
  TIM4->DIER |= TIM_DIER_UIE;              // TIM4 megszaktskrs engedlyezse
  NVIC_EnableIRQ(TIM4_IRQn);               // NVIC TIM4 megszaktsok engedlyezse	
  __enable_irq();                          // Megszaktsok globlis engedlyezse
 
  while (1) {  }                           // Nincs tbb tennival
}

void TIM4_IRQHandler(void) {               // Megszaktst kiszolgl eljrs
  TIM4->SR &= ~TIM_SR_UIF;                 // Megszaktskr bit trlse
  GPIOB->ODR ^= GPIO_ODR_ODR0|GPIO_ODR_ODR1; // PB0 s PB1 tbillentse
}



