/* Program05_6
 *
 * A PB0 kimenetre kttt LED villogtatsa 
 * kb 1 Hz frekvencival, Output Compare toggle mdban. 
 *
 * A Timer3 idzt 3. csatornjt 500 ms ksleltetsre lltjuk,  
 * s Output Compare (digitlis kompartor) mdban az "update esemnyek" 
 * bekvetkeztekor tbillentjk a PB0 kimenet llapott.
 * Timer3 az alaprtelmezett 72 MHz-es rajelet szmllja.
 * A 16 bites elszmllt gy lltjuk be, hogy a f szmll
 * 10 kHz-es rajelet kapjon, gy a szmll szmlllsi hatrt
 * kzvetlenl tized ms egysgekben tudjuk megadni.
 * 
 * Felhasznlt forrsok: 
 * - Mazidi et al., STM32 Arm Programming for Embedded Systems
 *   http://www.microdigitaled.com/ARM/STM_ARM_books.html
 * - Alexander Tarasov: Storming STM32 course
 *   http://themagicsmoke.ru/courses/stm32/
 * 
 * Tested with Keil MDK-Lite v5.28 and STM32F1 DFP v2.3.0
 */
 
#include "stm32f10x.h"

int main(void) {
  RCC->APB1ENR |= RCC_APB1ENR_TIM3EN;      // TIM3 rajel engedlyezs
  RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;      // AFIO rajel engedlyezs
  RCC->APB2ENR |= RCC_APB2ENR_IOPBEN;      // GPIOB rajel engedlyezs
  AFIO->MAPR &= ~AFIO_MAPR_TIM3_REMAP;     // Trli TIM3 REMAP bitjeit 
  //AFIO->MAPR |= AFIO_MAPR_TIM3_REMAP_NOREMAP; // 00: CH1/PA6, CH2/PA7, CH3/PB0, CH4/PB1   
  /* PB0 konfigurlsa T3C3 digitlis kimenetknt */
  GPIOB->CRL &= ~(GPIO_CRL_MODE0|GPIO_CRL_CNF0); // PB0 CNF s Mode bitek trlse
  GPIOB->CRL |=  GPIO_CRL_MODE0_0 |        // PB0 pushpull alternate kimenet, max. 50 MHz
                 GPIO_CRL_MODE0_1 |        // CNF: 10  MODE: 11
                 GPIO_CRL_CNF0_1; 
  /* Timer3 CH3 Output Compare md konfigurlsa */
  TIM3->PSC = SystemCoreClock/10000 - 1;   // 10 kHz-re osztjuk le az rajelet
  TIM3->ARR = 5000 - 1;                    // 5000-ig szmllunk (1000 ms)
  TIM3->CNT = 0;                           // Szmll nullzsa
  TIM3->CCMR2 = TIM_CCMR2_IC3F_1 | 
                TIM_CCMR2_IC3F_0 ;         // IC3F=0011 IC3PSC=00 CC3S=00 
  TIM3->CCR3 = 0;                          // Egyezsi rtk
  TIM3->CCER |= TIM_CCER_CC3E;             // CH3 kimenet engedlyezse
  TIM3->CNT = 0;                           // Szmll trlse
  TIM3->CR1 |= TIM_CR1_CEN;                // Szmlls indtsa

  while (1) {                              // Nincs mit tenni...
  }
}



