/* Program05_8
 *
 * Ez Program05_7 kibvtett vltozata, amelyben
 * az idblyeg rtkekbl kiszmoljuk a peridust s
 * print tirnyts segtsgvel SWO vonalon kiratjuk
 * az eredmnyt a debugger terminlablakba. A kirats
 * csak debug mdban mukdik!
 *
 * Tovbbi segtsg a program ellenrzshez, hogy a
 * PB1 kimenetre kttt LED llapott is tbillentjk 
 * minden Capture esemnynl. Ez a LED fele frekvencival
 * billeg a PB0-ra kttt LED-hez kpest.
 *
 * A PB0 kimenetet kb 1 Hz frekvencival billegtetjk,
 * Output Compare toggle mdban (TIM3 CH3). Kzben a vele
 * sszekttt PB6 bemeneten (TIM4 CH1) Input Capture 
 * mdban mrjk a peridusidt s eltroljuk egy globlis
 * vltozban, amit debug mdban olvashatunk ki.
 *
 * A Timer3 idzt 3. csatornjt 500 ms ksleltetsre lltjuk,  
 * s Output Compare (digitlis kompartor) mdban az "update esemnyek" 
 * bekvetkeztekor tbillentjk a PB0 kimenet llapott.
 * Timer3 az alaprtelmezett 72 MHz-es rajelet szmllja.
 * A 16 bites elszmllt gy lltjuk be, hogy a f szmll
 * 10 kHz-es rajelet kapjon, gy a szmll szmlllsi hatrt
 * kzvetlenl tized ms egysgekben tudjuk megadni.
 * 
 * Felhasznlt forrsok: 
 * - Mazidi et al., STM32 Arm Programming for Embedded Systems
 *   http://www.microdigitaled.com/ARM/STM_ARM_books.html
 * - Alexander Tarasov: Storming STM32 course
 *   http://themagicsmoke.ru/courses/stm32/
 * 
 * Tested with Keil MDK-Lite v5.28 and STM32F1 DFP v2.3.0
 */
 
#include "stm32f10x.h"
//----- print tirnyts ------------
#include <stdio.h>
#pragma import(__use_no_semihosting_swi)
struct __FILE { int handle; };
FILE __stdout;
FILE __stdin;

int fputc(int ch, FILE *f) {
  ITM_SendChar(ch);
  return (ch);
}

void _sys_exit(int return_code) {
  label:  goto label;  /* endless loop */
}
//--- print trnyts vge ---------

int timestamp = 0, period, prevtime=0;

int main(void) {
  RCC->APB1ENR |= RCC_APB1ENR_TIM3EN |
                  RCC_APB1ENR_TIM4EN;      // TIM3 s TIM4 engedlyezs
  RCC->APB2ENR |= RCC_APB2ENR_AFIOEN;      // AFIO rajel engedlyezs
  RCC->APB2ENR |= RCC_APB2ENR_IOPBEN;      // GPIOB rajel engedlyezs
  AFIO->MAPR &= ~AFIO_MAPR_TIM3_REMAP;     // Trli TIM3 REMAP bitjeit
  AFIO->MAPR &= ~AFIO_MAPR_TIM4_REMAP;     // Trli TIM4 REMAP bitjeit	 
  //--- PB0 konfigurlsa T3C3 digitlis kimenetknt -----------------
  GPIOB->CRL &= ~(GPIO_CRL_MODE0|GPIO_CRL_CNF0); // PB0 CNF s Mode bitek trlse
  GPIOB->CRL |=  GPIO_CRL_MODE0_0 |        // PB0 pushpull alternate kimenet, max. 50 MHz
                 GPIO_CRL_MODE0_1 |        // CNF: 10  MODE: 11
                 GPIO_CRL_CNF0_1; 
  GPIOB->CRL &= ~(GPIO_CRL_MODE1|GPIO_CRL_CNF1); // PB1 CNF s Mode bitek trlse
  GPIOB->CRL |=  GPIO_CRL_MODE1_1;         // PB1 pushpull kimenet, max. 2 MHz
  //--- PB6 konfigurlsa digitlis bemenetknt -----------------
  GPIOB->CRL &= ~(GPIO_CRL_MODE6|GPIO_CRL_CNF6); // PB6 CNF s Mode bitek trlse
  GPIOB->CRL |=  GPIO_CRL_CNF6_0;          // PB6 CNF: 01  MODE: 00 
  //--- Timer3 CH3 Output Compare md konfigurlsa ------------------
  TIM3->PSC = SystemCoreClock/10000 - 1;   // 10 kHz-re osztjuk le az rajelet
  TIM3->ARR = 5000 - 1;                    // 5000-ig szmllunk (1000 ms)
  TIM3->CNT = 0;                           // Szmll nullzsa
  TIM3->CCMR2 = TIM_CCMR2_IC3F_1 | 
                TIM_CCMR2_IC3F_0 ;         // IC3F=0011 IC3PSC=00 CC3S=00 
  TIM3->CCR3 = 0;                          // Egyezsi rtk
  TIM3->CCER |= TIM_CCER_CC3E;             // CH3 kimenet engedlyezse
  TIM3->CNT = 0;                           // Szmll trlse
  TIM3->CR1 |= TIM_CR1_CEN;                // Szmlls indtsa
  //--- TIM4 CH1 konfigurlsa Input Capture mdba -----
  TIM4->PSC = SystemCoreClock/10000 - 1;   // 10 kHz-re osztjuk le az rajelet
  TIM4->CNT = 0;                           // Szmll nullzsa
  TIM4->CCMR1 = TIM_CCMR1_CC1S_0;          // Input capture, no filter, no prescaler  
  TIM4->CCER &= TIM_CCER_CC1P;             // CH1 felfut lre rzkeny	
  TIM4->CCER |= TIM_CCER_CC1E;             // CH1 bemenet engedlyezse
  TIM4->CR1  |= TIM_CR1_CEN;               // Szmll indtsa

  while (1) {
    while (!(TIM4->SR & TIM_SR_CC1IF));    // Capture esemnyre vrunk
    timestamp = TIM4->CCR1;                // A kiolvass trli a jelzbitet
		period = timestamp - prevtime;
		if(period<0) period += 65536;          // Tlcsorduls korrekci
		prevtime = timestamp;
		GPIOB->ODR ^= GPIO_ODR_ODR1;           // PB1 tbillentse
		printf("T = %d\n",period);
  }
}



